# -*- mode: ruby -*-
# vi: set ft=ruby :

servers = [
    { :hostname => "develop",    :ip_addr => "192.168.100.10" },
    { :hostname => "production", :ip_addr => "192.168.100.11" },
  ]

Vagrant.configure("2") do |config|
  config.vm.box = "ubuntu/focal65"

  def create_vm(config, hostname, ip, cpus=2, memory=4096)
    config.vm.define hostname do |host|
      host.vm.network "private_network", ip: ip
      host.vm.hostname = hostname

      host.vm.provider "virtualbox" do |vm|
        vm.name = "Vagrant_#{hostname}"
        vm.customize ["modifyvm", :id, "--cpus", cpus.to_s]
        vm.customize ["modifyvm", :id, "--memory", memory.to_s]
        vm.customize ["modifyvm", :id, "--audio", "none"]
        end
      yield host if block_given?
    end
  end

  servers.each do |vm|
    create_vm(config, vm[:hostname], vm[:ip_addr]) do |host|
      if vm[:hostname] == "production"
        host.vm.provision :ansible do |ansible|
          ansible.limit = "all"
          ansible.playbook = "../ansible/playbook_vagrant.yml"
          # ansible.raw_arguments = ["-vvvvv"]
          ansible.groups = {
            "dev"          => ["develop"],
            "prod"         => ["production"],
            "all:children" => ["dev", "prod"],
            "all:vars"     => {
              "docker_users"                     => ["gitlab-runner", "vagrant"],
              "gitlab_runner_registration_token" => "GR1348941osgD4tXBHgamvo94ozpY"}, # Можно убрать в env
            "dev:vars"     => {
              "gitlab_runner_working_stage"      => "dev",
              "gitlab_runner_config_executor"    => ["docker", "shell"]},
            "prod:vars"    => {
              "gitlab_runner_working_stage"      => "prod",
              "gitlab_runner_config_executor"    => ["shell",]}
          }
        end
      end
    end
  end
end
